﻿local Engine, Api, Locale, Settings = unpack(Vendetta)

-- Registration
local Configuration = Engine:RegisterModule("Configuration", { Priority = 100, IsImmediate = false })

-- Initialize the module.
function Configuration:OnInitialize()
	-- Register module options, force Configuration to run first
	Configuration:RegisterOptions()
	
	-- Delay the registration of module options until after all modules are registered
	for name, module in pairs(Engine.Modules) do
		if name ~= "Configuration" then
			module:RegisterOptions()
		end
	end

	Configuration:RegisterProfiles()
end

-- Called when the module is enabled.
function Configuration:OnEnable()
	if Settings:IsDebug() then
		self:EnableProfiler()
	end
end

-- Called when the module is disabled.
function Configuration:OnDisable()
	Configuration:DisableProfiler()
end

-- Register the default settings for the module.
function Configuration:OnRegisterDefaults()
	return { Enabled = true }
end